package nio01;

import java.nio.ByteBuffer;

import org.junit.Test;

/**
 * һ(Buffer)NIOиݵĴȡ屾ʾ顣
 * ڴ洢ͬ͵
 * ͵Ĳͬ*Boolean⣩ṩӦ͵Ļ
 * ByteBuffer,CharBuffer,ShortBuffer,IntBuffer,LongBuffer,FloatBuffer,DoubleBuffer
 * 
 * Ĺʽһ£ͨallocateȡ
 * 
 * 
 * ȡݵĺķ
 * put()ݵ
 * get()ȡ
 * 
 * ĸԣ
 * capacity,ʾ洢ݵһܸı
 * limit޽磬ʾпԲݵĴСlimit ǲܽжд
 * positionλáʾڲݵλá
 * 
 * mark:ڼ¼ǰpositionλáͨreset()ָmarkλá
 * 0<=mark<=position<=limit<=capacity
 * 
 * ġֱӻֱӻ
 * ֱӻͨallocate()仺JVMڴС
 * ֱӻͨallocateDirect()ֱӻڴСЧʣ
 * 
 * 
 * @author fulanduolu
 *
 */
public class TestBuffer {

	@Test
	public void test1(){
		//1.ͨallocateһָСĻ
		ByteBuffer buf=ByteBuffer.allocate(1024);
		
		System.out.println("==========allocate֮");
		//鿴ǰλ
		System.out.println(buf.position());
		//鿴޽
		System.out.println(buf.limit());
		//鿴洢
		System.out.println(buf.capacity());
		
		//put()ݵ
		String str="fulan";
		buf.put(str.getBytes());
		System.out.println(buf.position());
		System.out.println(buf.limit());
		System.out.println(buf.capacity());
		
		//ģʽ
		buf.flip();
		System.out.println("=======");
		System.out.println(buf.position());
		System.out.println(buf.limit());
		System.out.println(buf.capacity());
		
		//getȡ
		byte[] bst=new byte[buf.limit()];
		buf.get(bst);
		System.out.println(new String(bst,0,bst.length));
		
		//ȡ
		System.out.println("=======ȡ");
		System.out.println(buf.position());
		System.out.println(buf.limit());
		System.out.println(buf.capacity());
		
		
		//rewind()Ὣposition0ظȡݡ
		buf.rewind();
		System.out.println("=======rewind()");
		System.out.println(buf.position());
		System.out.println(buf.limit());
		System.out.println(buf.capacity());
	
		//clear():ջ,ǻݻڵġֻЩݣ""״̬
		buf.clear();
		System.out.println(buf.position());
		System.out.println(buf.limit());
		System.out.println(buf.capacity());
		
		System.out.println((char)buf.get());
	}
	
	@Test
	public void test2(){
		String str="leimi";
		ByteBuffer buf=ByteBuffer.allocate(1024);
		buf.put(str.getBytes());
		buf.flip();
		byte[] bst=new byte[buf.limit()];
		buf.get(bst,0,2);
		System.out.println(new String(bst,0,2));
		
		System.out.println(buf.position());
		
		//mark():
		buf.mark();
		buf.get(bst,2,2);
		System.out.println(new String(bst,2,2));
		System.out.println(buf.position());
		//ָǵλ
		buf.reset();
		System.out.println(buf.position());
		
		System.out.println(buf.hasRemaining());
		//жϻǷʣݣ
		//ȡпԲݵ	
		if(buf.hasRemaining()){
			System.out.println(buf.remaining());
		}
	}
	
	@Test
	public void test3(){
		//ֱӻ
		ByteBuffer buf=ByteBuffer.allocateDirect(1024);
		//жǲֱӻ
		System.out.println(buf.isDirect());
		
	}
}
